function sdkp:IsShowingDialog()
	return self.dialogOpen;
end

function sdkp:SetShowingDialog(showing)
	self.dialogOpen = not not showing;
end

function sdkp:GetNextDialog()
    if not self.dialogQueue then
    	self.dialogQueue = {};
    end
    local size = #self.dialogQueue;
    local dialogInfo = nil;
    if size > 0 then 
    	dialogInfo = self.dialogQueue[size];
    	self.dialogQueue[size] = nil;
    end
    return dialogInfo;
end

function sdkp:EnqueueDialog(sMessage, sYes, sNo, fnYes, fnNo, sEditText)
    if not self.dialogQueue then
    	self.dialogQueue = {};
    end
    local dialogInfo = {
    	["sMessage"] = sMessage,
    	["sYes"] = sYes, 
    	["sNo"] = sNo, 
    	["fnYes"] = fnYes, 
    	["fnNo"] = fnNo, 
    	["sEditText"] = sEditText,
    };
    table.insert(self.dialogQueue, 1, dialogInfo);
end

function sdkp:ConfirmPopup(fForce)
	if (not fForce and self:IsShowingDialog()) or UnitAffectingCombat("player") then 
		return;
	end
	local dialogInfo = sdkp:GetNextDialog();
	if not dialogInfo then 
		return;
	end
	
	if not StaticPopupDialogs["SDKP_CONFIRM_DIALOG"] then
		StaticPopupDialogs["SDKP_CONFIRM_DIALOG"] = {hideOnEscape = 1};
	end
	local dialog = StaticPopupDialogs["SDKP_CONFIRM_DIALOG"];
	for key in pairs(dialog) do
		dialog[key] = nil;
	end
	dialog.text = dialogInfo.sMessage;
	dialog.button1 = dialogInfo.sYes;
	dialog.button2 = dialogInfo.sNo;
	dialog.OnAccept = function ()
		local data = nil;
		if dialogInfo.sEditText then 
			data = getglobal(this:GetParent():GetName().."EditBox"):GetText();
		end
		dialogInfo.fnYes(data);
	end;
	dialog.OnCancel = dialogInfo.fnNo;
	
	dialog.OnShow = function()
		if dialogInfo.sEditText then
			getglobal(this:GetName().."EditBox"):SetText(dialogInfo.sEditText);
		end
		self:SetShowingDialog(true);	
	end;
	dialog.OnHide = function ()
		if #self.dialogQueue > 0 then 
			sdkp:ConfirmPopup(true);
		else
			self:SetShowingDialog(false);
		end
	end;
	
	if dialogInfo.sEditText then 
		dialog.hasEditBox = 1;
		dialog.EditBoxOnEnterPressed = function()
			dialog.OnAccept();
			this:GetParent():Hide();
		end;
		dialog.EditBoxOnEscapePressed = function()
			dialog.OnCancel();
			this:GetParent():Hide();
		end;
	end
	dialog.timeout = 0;
	dialog.whileDead = 1;
	dialog.hideOnEscape = 1;
	StaticPopup_Show("SDKP_CONFIRM_DIALOG");
end